# Python imports
from StringIO import StringIO
from types import TupleType

# Zope imports
import zLOG

# Plone imports
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFCore.utils import getToolByName

# Local imports
from Products.PloneLocalFolderNG.config import *
from Products.PloneLocalFolderNG.CatalogProxy import CatalogProxy
from Products.PloneLocalFolderNG.PloneLocalFolderNGTool import PloneLocalFolderNGTool

# Which tools need installation
# List of tool ids
tools = (PloneLocalFolderNGTool.id,)

def installCatalogProxyType(portal):
    """ Creates PloneLocalFolderNGFileProxy portal_type
    
    This is required so that file objects are propeply available
    when calling PloneTool.createNavTree. Otherwise it's a fake type,
    the user shouldn't try to add it manually.
    
    @param portal Plone portal object
    """
    
    types_tool = portal.portal_types
    
    type_information = 'Factory-based Type Information'
    name = PROJECTNAME + ": " + CatalogProxy.portal_type + " (" + CatalogProxy.portal_type + ")"
    type = types_tool.manage_addTypeInformation(type_information, id=CatalogProxy.portal_type, typeinfo_name=name)      

def registerStylesheets(self, out, stylesheets):
    # register additional CSS stylesheets with portal_css
    csstool = getToolByName(self, 'portal_css')
    for css in stylesheets:
        csstool.registerStylesheet(**css)
    print >> out, "installed the Plone additional stylesheets."    
    
    
def setupTools(portal, out):
    """ Register PLFNG tool to portal

    """
    
    # Install UsabilityTool tool             
    if not hasattr(portal, PloneLocalFolderNGTool.id):
        portal.manage_addProduct[PROJECTNAME].manage_addTool(PloneLocalFolderNGTool.meta_type)        
        print >> out, 'tool installed'    

def install(self):
    out = StringIO()
    
    # parentMetaTypesNotToQuery property for portal_properties/navtree_properties
    # must include 'PloneLocalFolderNG' to prevent duplicate folders from being
    # generated in the navtree when a PLFNG object is selected
    url_tool = getToolByName( self, 'portal_url')	
    
    # TODO: This was previous implementation which prevented
    # items getting listed in sitemap
    
    #portal = url_tool.getPortalObject()
    #props = portal.portal_properties.navtree_properties
    #if props.hasProperty('parentMetaTypesNotToQuery'):
    #    data = getattr(props, 'parentMetaTypesNotToQuery')
    #    data = list(data)
    #    if not 'PloneLocalFolderNG' in data:
    #         data.append('PloneLocalFolderNG')
    #         props._updateProperty('parentMetaTypesNotToQuery', data)
    #         print >> out, "updated parentMetaTypesNotToQuery property with values: %s" % data
    #    else:
    #         print >> out, "parentMetaTypesNotToQuery property already includes PloneLocalFolderNG"
    #else:
    #    print >> out, "ERROR: parentMetaTypesNotToQuery property not found!!!"
        
    
    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)
       
    installCatalogProxyType(self)
    
    registerStylesheets(self, out, STYLESHEETS)

    install_subskin(self, out, GLOBALS)
    
    setupTools(self, out)

    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()
