from OFS.SimpleItem import SimpleItem
from AccessControl import ClassSecurityInfo

class LocalFolderFilterType( SimpleItem ):
   """ 
   the purpose of this data object is to hold all of the display policy
   filter parameters for one or more LocalFolders.  Most likely, many
   LocalFolders within a site will have the same policy.
   """ 
   
   security = ClassSecurityInfo()
   
   def __init__(self, **kwargs):

       self.id = kwargs.get('id', 'default')
       
       self.hidden_file_prefixes = kwargs.get('hidden_file_prefixes', '.')
       
       self.hidden_file_suffixes = \
          kwargs.get('hidden_file_suffixes', '.metadata,.plfngtmp')
          
       self.hidden_file_names = kwargs.get('hidden_file_names', '')
       
       self.hidden_folder_prefixes= kwargs.get('hidden_file_prefixes', '.')
       
       self.hidden_folder_suffixes = \
          kwargs.get('hidden_folder_suffixes', '.metadata,.plfngtmp')
          
       self.hidden_folder_names = kwargs.get('hidden_folder_names', 'CVS')


   def set(self, **kwargs):
   
       if kwargs.has_key('id'):
           self.id = kwargs['id']

       if kwargs.has_key('hidden_file_prefixes'):
           self.hidden_file_prefixes = kwargs['hidden_file_prefixes']
       
       if kwargs.has_key('hidden_file_suffixes'):
           self.hidden_file_suffixes = kwargs['hidden_file_suffixes']
       
       if kwargs.has_key('hidden_file_names'):
           self.hidden_file_names = kwargs['hidden_file_names']
           
       if kwargs.has_key('hidden_folder_prefixes'):
           self.hidden_folder_prefixes = kwargs['hidden_folder_prefixes']    
       
       if kwargs.has_key('hidden_folder_suffixes'):
           self.hidden_folder_suffixes = kwargs['hidden_folder_suffixes']
       
       if kwargs.has_key('hidden_folder_names'):
           self.hidden_folder_names = kwargs['hidden_folder_names']
