import zLOG
import os
from AccessControl import getSecurityManager
from Products.CMFCore.utils import getToolByName

try:
    from Products.mxmCounter import mxmCounter
except ImportError:
    #msg = "Warning: mxmCounter was not imported"
    #zLOG.LOG('PloneLocalFolderNG', zLOG.INFO , msg)
    mxmCounter = None

def _onFileAccess(self, **kw):
    """ 
    This method is called from showFile().  Customize it to suit the needs of
    your site.  For example, some sites need to know how many times specific 
    files on have been accessed.  Also, some sites need to log file accesses 
    on a user by user basis.  Examples of how to accomplish these types of 
    activities are provided below.  Note that 'FSFullPath' is the only param
    that PLFNG currently provides.  
    """

    fileAccessed = kw['FSFullPath']
    
    security = getSecurityManager()
    userNameOfFileAccesser = security.getUser().getId()
    
    # -------------------------------------------------------------------------
    # count file accesses
    # -------------------------------------------------------------------------
    if hasattr(self, "count_file_accesses") and self.count_file_accesses:
       
       # example #1: use mxmCounter hit counter
       # mxmCounter (v1.1.0, http://www.mxm.dk/products/public/mxmCounter)
       # is a nice little hit counter, but to get it to count hits on PLFNG
       # files, I opted to call it here since PLFNG files don't show with the
       # standard footer.pt where I place the mxmCounter::count() routine.
       #
       #   Note: for the following code to work with mxmCounter (v1.1.0), you
       #         will need to modify/extend the mxmCounter class by adding the
       #         following method:
       #
       #         def proxyObject_increase_count(self,url_path):
       #            return increase_count(url_path, self.save_interval)
       #
       #   I have contacted the mxmCounter author to ask that this type of
       #   functionality be added to the baseline of mxmCounter.
       if mxmCounter:
          REQUEST = self.REQUEST
          url_path = REQUEST['URLPATH0']
          this_portal = getToolByName(self, 'portal_url')
          try:
             mxmCounter_obj = getattr(this_portal, 'mxm_counter')
             mxmCounter_obj.proxyObject_increase_count(url_path)
          except:
             zLOG.LOG('PloneLocalFolderNG', zLOG.INFO , "showFile() :: \
               there was a problem with mxmCounter" )

    # -------------------------------------------------------------------------
    # log file accesses
    # -------------------------------------------------------------------------
    if hasattr(self, "log_file_accesses") and self.log_file_accesses:
       
       # example #1: log to Plone's event.log
       # uncomment the following to use Plone's event.log file as the event logger
       #zLOG.LOG('PloneLocalFolderNG', zLOG.INFO , 
       #         "_onFileAccess() :: '%s' accessed %s" % \
       #         (userNameOfFileAccesser,fileAccessed) )
       
       # example #2: log via custom logEvent() method of user folder mechanism
       # note: you will need to add a logEvent() method to your user folder
       # mechanism in order for the following code to do anything! 
   
       try:
          self.acl_users.logEvent(subsystem=10,
                                  securityRelated=1,
                                  eventSeverity=2,
                                  remoteIP='',
                                  clientAccountID=userNameOfFileAccesser,
                                  eventType=15,
                                  eventValue1=str(os.path.basename(fileAccessed)),
                                  eventValue2=str(fileAccessed) )
       except:
          pass


